//+------------------------------------------------------------------+
//|                                                       .mq5 |
//|              Copyright Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//--- input parameters
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int  P1Cycle=50;                  //     
extern bool CloseOrderALL=false;         //  true     
int         NExp=0,                      //  
            NTik,mode,OP,MA55_handle,total;

datetime       T1Cycle=0,                //   
               T1CycleCR=0,              //     
               T2Cycle=0,                //   
               TN=0;
int            Par=9;                    //     

string SymbolsArray[9]={"EURUSD","USDCHF","GBPUSD","USDJPY","USDCAD","AUDUSD","EURAUD","GBPJPY","EURJPY"};

double PercentLots1Cycle=0.1,//      10%,      1- 
       Lot,
       B=0,
       dAsk,dBid,dSprd,price,MA55[],
       AccountPred,AccountCR,p=0,q=1,p1,q1;

bool   Flag=false;
//  
//--------------------------------------------------------------------          
string GetSymbolString(int Number)
  {
   string res="";
   res=SymbolsArray[Number];
   return(res);
  }
//+------------------------------------------------------------------+
//|                      |
//+------------------------------------------------------------------+
int SendActionOrder(string instr,int ordertype,double volume,double price)
  {
//---  
   MqlTradeRequest request;
   request.action=TRADE_ACTION_DEAL;               //   
   request.symbol=instr;                           // 
   request.volume=volume;                          //   0.1      
   request.price=price;                            // 
   request.stoplimit=0;                            //  StopLimit 
   request.sl=0;                                   // Stop Loss  
   request.tp=0;                                   // Take Profit  
   request.deviation=500;                          //      
//---   
   request.type=ordertype;                         //  
   request.type_filling=ORDER_FILLING_AON;         //       
   request.type_time=ORDER_TIME_GTC;               //        
   request.expiration=0;                           //    (   ORDER_TIME_SPECIFIED)
//---   
   MqlTradeResult result;
bool success=OrderSend(request,result);
//---       
//---    -     
   if(!success)
     {
      int answer=result.retcode;
      Print("TradeLog:Trade request failed. Error =",GetLastError());
      switch(answer)
        {
         //--- 
         case 10004:
           {
            Print("TRADE_RETCODE_REQUOTE");
            Print("request.price =",request.price,"   result.ask =",
                  result.ask," result.bid =",result.bid);
            break;
           }
         //---    
         case 10006:
           {
            Print("TRADE_RETCODE_REJECT");
            Print("request.price =",request.price,"   result.ask =",
                  result.ask," result.bid =",result.bid);
            break;
           }
         //---  
         case 10015:
           {
            Print("TRADE_RETCODE_INVALID_PRICE");
            Print("request.price =",request.price,"   result.ask =",
                  result.ask," result.bid =",result.bid);
            break;
           }
         //---  SL / TP
         case 10016:
           {
            Print("TRADE_RETCODE_INVALID_STOPS");
            Print("request.sl =",request.sl," request.tp =",request.tp);
            Print("result.ask =",result.ask," result.bid =",result.bid);
            break;
           }
         //---  
         case 10014:
           {
            Print("TRADE_RETCODE_INVALID_VOLUME");
            Print("request.volume =",request.volume,"   result.volume =",
                  result.volume);
            break;
           }
         //---        
         case 10019:
           {
            Print("TRADE_RETCODE_NO_MONEY");
            Print("request.volume =",request.volume,"   result.volume =",
                  result.volume,"   result.comment =",result.comment);
            break;
           }
         //--- -  ,       
         default:
           {
            Print("Other answer =",answer);
           }
        }
      //---        false
      return(false);
     }
//--- OrderSend()  true -  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
  
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
     MA55_handle=iMA("EURUSD",PERIOD_M15,55,0,MODE_EMA,PRICE_TYPICAL);
     B=AccountInfoDouble(ACCOUNT_BALANCE);
     AccountPred=0;
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ObjectDelete(0,"label_object");
   ObjectDelete(0,"label_object1");
   ObjectDelete(0,"label_object2");
   ObjectDelete(0,"label_object3");
   ObjectDelete(0,"label_object4");
   ObjectDelete(0,"label_object5");
   ObjectDelete(0,"label_object6");
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   int     error,d,n;
   bool    result;
   double  price;

   CopyBuffer(MA55_handle,0,0,100,MA55);
   ArraySetAsSeries(MA55,true);
   
   total = PositionsTotal();
   
   if(total < 1)
     {
      //          
      NExp++;
      TN=TimeCurrent();                                                   //    
      AccountCR=0;

      dAsk=SymbolInfoDouble("EURUSD",SYMBOL_ASK);

      if(MA55[0]>dAsk){mode=ORDER_TYPE_SELL;}
      else {mode=ORDER_TYPE_BUY;}

      for(int SymbolIndex=0;SymbolIndex<9;SymbolIndex++)
        {
         while(true)
           {
            Lot=0.1;
            if(mode==ORDER_TYPE_BUY)price=SymbolInfoDouble(SymbolsArray[SymbolIndex],SYMBOL_ASK);
            if(mode==ORDER_TYPE_SELL)price=SymbolInfoDouble(SymbolsArray[SymbolIndex],SYMBOL_BID);
            dSprd=SymbolInfoInteger(SymbolsArray[SymbolIndex],SYMBOL_SPREAD);
            ResetLastError();

            result=SendActionOrder(SymbolsArray[SymbolIndex],mode,Lot,price);
            
            if(result!=true) { error=GetLastError(); Print("LastError = ",error); }
            else {error=0;break;}
           }
        }
     }

  }
//+------------------------------------------------------------------+
